`define DECIMAL 0
`define OPE 1
`define HALT 2
  module calc(decimal,plus,minus,equal,CLK,RST,CE,sign,overflow,out);
    input [9:0] decimal;
    input CLK,CE,RST,plus,minus,equal;
    output sign,overflow;
    output [6:0] out;
    wire [3:0] d;
    wire [8:0] alu_out;
    reg [1:0] state;
    reg [8:0] REGA, REGB;
    reg [1:0] count;
    reg add_or_sub;
    function [3:0] dectobin;
      input [9:0] in;
      if(in[9])
	dectobin = 9;
      else if(in[8])
	dectobin = 8;
      else if(in[7])
	dectobin = 7;
      else if(in[6])
	dectobin = 6;
      else if(in[5])
	dectobin = 5;
      else if(in[4])
	dectobin = 4;
      else if(in[3])
	dectobin = 3;
      else if(in[2])
	dectobin = 2;
      else if(in[1])
	dectobin = 1;
      else if(in[0])
	dectobin = 0;
    endfunction
    assign d=dectobin(decimal);
    always @(posedge CLK or negedge RST)
      begin
	if(!RST)
	  begin
	    REGA<=0;REGB<=0;count<=0;
	    add_or_sub<=0;
	    state<=`DECIMAL;
	  end
	else
	  begin
	    case(state)
	      `DECIMAL:
		begin
		  if((decimal!=0) && (count < 2))
		    begin
		      count<=count+1;
		      REGA<=REGA*10+d;
		    end
		  else if(CE)
		    begin
		      REGA<=0;
		      count<=0;
		    end
		  else if(plus || minus || equal)
		    begin
		      if(add_or_sub==0)
			REGB<=REGB+REGA;
		      else
			REGB<=REGB-REGA;
		      if(plus)
			add_or_sub<=0;
		      else if(minus)
			add_or_sub<=1;
		      state<=`OPE;
		    end
		end
	      `OPE:
		begin
		  if(((REGB[8]==1)&&(REGB<413))
		    ||((REGB[8]==0)&&(REGB>99)))
		      state<=`HALT;
		  else if(decimal)
		    begin
		      REGB<=REGA;
		      REGA<=d;
		      count <= 1;
		      state<=`DECIMAL;
		    end
		end
	      `HALT:
		begin
		  if(CE)
		    begin
		      REGA<=0;
		      REGB<=0;
		      add_or_sub<=0;
		      count<=0;
		      state<=`DECIMAL;
		    end
		end
	    endcase
	  end
      end
    assign out=(state==`OPE)?((REGB[8]==0)?REGB[6:0]:~REGB[6:0]+1):REGA;
    assign sign=REGB[8];
    assign overflow=(state==`HALT)?1:0;
  endmodule
