`timescale 1ns / 100 ps
module main;
  reg [9:0] push;
  reg plus,minus,equal,CLK,CE,RST;
  wire [6:0] ledl,ledh;
  wire     sign,overflow;
  wire [6:0] ledsign;
  calctop  I0(.push(~push),.plus(!plus),.minus(!minus),
    .equal(!equal),.ledsign({ledsign}),.overflow(overflow),.ledl(ledl),.ledh(ledh),
      .CLK(CLK),.CE(~CE),.RST(~RST));
  assign  sign=ledsign[6];
  always #10 CLK = ~CLK ;
  initial 
    begin
       $calc_init;
       push=0;plus=0;minus=0;equal=0;CE=0;RST=0;CLK=0;
    end
   always #200
     begin
	$calc_input(push,plus,minus,equal,CE,RST);
	#200
	$calc_clear(push,plus,minus,equal,CE,RST);
     end // UNMATCHED !!
   always @(ledl or ledh or sign)
     begin
	$display_led(sign,ledh,ledl,overflow);
     end
   initial
     begin
	$timeformat(-9,0,"ns",6);
	$monitor($realtime,"push=%b,plus=%b,minus=%b,equal=%b,CE=%b,RST=%b,sign=%b,overflow=%b,ledh=%b,ledl=%b",
	    push,plus,minus,equal,CE,RST,sign,overflow,ledh,ledl);
     end
  initial
      begin
      $dumpfile("calctop.vcd");
      $dumpvars;
    end
endmodule
