/* 
   $Header: /kazunoko/kobayashi/local/verilog/pli/gtkcalc/RCS/gtk_calc_pli.c,v 1.2 2005/09/02 08:01:51 kobayasi Exp kobayasi $
   gtk_calc.c
 */

#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>

#include <sys/types.h>
#include <string.h>
/*
#include <unistd.h>
*/
#ifdef PLI
#include <veriuser.h> 
#ifdef CVER
#include <cv_veriuser.h> 
#endif
#ifdef XL
#include <vxl_veriuser.h> 
#endif
#include <acc_user.h>
#else
#include "plidef.h"
#endif
#define ADD 10
#define SUB 11
#define EQU 12
#define CE  13
s_acc_value push,plus,minus,equal,ce,rst;
#ifdef PLI
s_setval_delay delay_none;
#endif
void calc_software(void);
int  calc_init();
void quit_button_clicked(GtkWidget *widget, gpointer data);
void rst_button_clicked(GtkWidget *widget, gpointer data);
void digit_button_clicked(GtkWidget *widget, gpointer data);
void operate_button_clicked(GtkWidget *widget, gpointer data);
       
GtkWidget *window;
GtkWidget *table;
GtkWidget *button;
GtkWidget *vbox;
GtkWidget *led_area;
GdkPixmap *pixmap;
GdkGC *g_pen,*g_back;
#define LED_WIDTH 200
#define LED_HEIGHT 150
int ledl=0;
int ledh=0;
int sign=0;
int overflow=0;
typedef struct
{
  int x0;
  int y0;
  int x1;
  int y1;
    }  coordinates;

static coordinates sevensegments[] = 
  {{0,0,50,0},{50,0,50,50},{50,50,50,100},{50,100,0,100},
   {0,100,0,50},{0,50,0,0},{0,50,50,50}};
void CreateBackground(GdkWindow *window)
{
  g_back = gdk_gc_new(window);
  gdk_gc_set_line_attributes(
    g_back,            // GdkGC*
    2,              // line_width
    GDK_LINE_SOLID, // line_style
    GDK_CAP_ROUND,  // cap_style
    GDK_JOIN_ROUND  // joint_style
  );
}
void SetBackColor(int red, int green, int blue)
{
  GdkColor  color;
  color.red = red;
  color.green = green;
  color.blue = blue;
//  color.pixel = 8;

  /** $B?'$r3NJ](B **/
  gdk_color_alloc(gdk_colormap_get_system(),&color);

  /** $BA07J?'$r@_Dj(B **/
  gdk_gc_set_foreground(g_back, &color);
}

void CreatePen(GdkWindow *window)
{
  g_pen = gdk_gc_new(window);
  gdk_gc_set_line_attributes(
    g_pen,            // GdkGC*
    2,              // line_width
    GDK_LINE_SOLID, // line_style
    GDK_CAP_ROUND,  // cap_style
    GDK_JOIN_ROUND  // joint_style
  );
}
void SetPenColor(int red, int green, int blue)
{
  GdkColor  color;

  color.red = red;
  color.green = green;
  color.blue = blue;
//  color.pixel = 8;

  /** $B?'$r3NJ](B **/
  gdk_color_alloc(gdk_colormap_get_system(),&color);

  /** $BA07J?'$r@_Dj(B **/
  gdk_gc_set_foreground(g_pen, &color);
}
void SetPenSize(gint penSize)
{
  gdk_gc_set_line_attributes(
    g_pen,            // GdkGC*
    penSize,          // line_width
    GDK_LINE_SOLID,   // line_style
    GDK_CAP_ROUND,    // cap_style
    GDK_JOIN_ROUND    // joint_style
  );
}

void drawled(int led,int x0,int y0)
{
  int i;
  for(i=0;i<7;i++){
    if(led&(1<<i)){
      SetPenColor(0xffff,0,0);
    }else{
      SetPenColor(0x8000,0x1000,0x1000);
    }
    gdk_draw_line(pixmap,g_pen,
		  sevensegments[i].x0+x0,sevensegments[i].y0+y0,
		  sevensegments[i].x1+x0,sevensegments[i].y1+y0);
  }
}
void drawled1(int led,int x0,int y0)
{
  int i;
  if(led!=0){
      SetPenColor(0xffff,0,0);
  }else{
      SetPenColor(0x8000,0x1000,0x1000);
  }
  gdk_draw_line(pixmap,g_pen,
		  0+x0,0+y0,
		  10+x0,0+y0);
}

gint expose_event(GtkWidget *widget, GdkEventExpose *event)
{
  gdk_draw_rectangle( pixmap,
		      g_back,
		      TRUE,
		      0, 0,
		      LED_WIDTH, LED_HEIGHT);
  drawled1(overflow,5,5);
  //  printf("overflow=%x\n",overflow);
  drawled(sign<<6,5,25);
  drawled(ledh,75,25);
  drawled(ledl,145,25);
  /** $B%T%C%/%9%^%C%W$+$i%3%T!<(B **/
  if(event == NULL){
    gdk_draw_pixmap(widget->window,
		  widget->style->black_gc,
		  pixmap,
		  0,0,
		  0,0,
		    LED_WIDTH,LED_HEIGHT);
  }
  else{
    gdk_draw_pixmap(widget->window,
		  widget->style->black_gc,
		  pixmap,
		  event->area.x, event->area.y,
		  event->area.x, event->area.y,
		    event->area.width, event->area.height);
  }
  return FALSE;
}

GtkWidget * create_drawing_area(void)
{
  GtkWidget *g_drawing_area;
  /** $B%I%m!<%$%s%0%(%j%"@8@.(B **/
  g_drawing_area = gtk_drawing_area_new();
  /** $B%I%m!<%$%s%0%(%j%"$N%5%$%:@_Dj(B **/
  gtk_drawing_area_size( GTK_DRAWING_AREA(g_drawing_area),
			 LED_WIDTH, LED_HEIGHT);

  /** "expose_event"$B%$%Y%s%H%O%s%I%i@_Dj(B **/
  gtk_signal_connect(GTK_OBJECT(g_drawing_area), "expose_event",
		     (GtkSignalFunc) expose_event, NULL);
  /** $B%$%Y%s%H%^%9%/@_Dj(B **/
  /*
  gtk_widget_set_events(g_drawing_area, GDK_EXPOSURE_MASK
			 | GDK_LEAVE_NOTIFY_MASK
			 | GDK_BUTTON_PRESS_MASK
			 | GDK_POINTER_MOTION_MASK
			 | GDK_POINTER_MOTION_HINT_MASK);
  */

  pixmap = gdk_pixmap_new(window->window,
			    LED_WIDTH, LED_HEIGHT,
			    -1);

  /** $B%T%C%/%9%^%C%W$rGrEI$j(B **/
  gdk_draw_rectangle( pixmap,
		      g_back,
		      TRUE,
		      0, 0,
		      LED_WIDTH, LED_HEIGHT);
  return(g_drawing_area);
}
       
int calc_init()
{
	push.format=accIntVal;
	plus.format=accIntVal;
	minus.format=accIntVal;
	equal.format=accIntVal;
	ce.format=accIntVal;
	rst.format=accIntVal;
#ifdef PLI
	delay_none.model=accNoDelay;
	delay_none.time.type=accRealTime;
	delay_none.time.real=0;
#endif
	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_widget_show(window);
	CreateBackground(window->window);
	CreatePen(window->window);
	SetPenColor(0xffff,0,0);
	SetBackColor(0x0000,0x0000,0x0000);
	SetPenSize(4);
	vbox=gtk_vbox_new(FALSE,0);
	gtk_signal_connect(GTK_OBJECT(window), "destroy",
					   GTK_SIGNAL_FUNC(gtk_main_quit), NULL);
	gtk_window_set_title(GTK_WINDOW(window), "calculator");
	gtk_container_border_width(GTK_CONTAINER(window), 5);
	gtk_container_add(GTK_CONTAINER(window), vbox);

	led_area=create_drawing_area();
	gtk_box_pack_start(GTK_BOX(vbox),led_area,TRUE, TRUE, 0);

	table = gtk_table_new(6, 5, TRUE);
	gtk_box_pack_start(GTK_BOX(vbox),table,FALSE, FALSE, 0);

	gtk_widget_show(led_area);
	gtk_widget_show(table);

	gtk_widget_show(vbox);

	button = gtk_button_new_with_label("7");
	gtk_table_attach_defaults (GTK_TABLE(table), button, 0, 1, 1, 2);
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
					   GTK_SIGNAL_FUNC(digit_button_clicked),
					   (gpointer)7);
	gtk_widget_show(button);
	
	button = gtk_button_new_with_label("8");
	gtk_table_attach_defaults (GTK_TABLE(table), button, 1, 2, 1, 2);
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
					   GTK_SIGNAL_FUNC(digit_button_clicked),
					   (gpointer)8);
	gtk_widget_show(button);
       
	button = gtk_button_new_with_label("9");
	gtk_table_attach_defaults (GTK_TABLE(table), button, 2, 3, 1, 2);
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
					   GTK_SIGNAL_FUNC(digit_button_clicked),
					   (gpointer)9);
	gtk_widget_show(button);
	button = gtk_button_new_with_label("4");
	gtk_table_attach_defaults (GTK_TABLE(table), button, 0, 1, 2, 3);
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
					   GTK_SIGNAL_FUNC(digit_button_clicked),
					   (gpointer)4);
	gtk_widget_show(button);
       
	button = gtk_button_new_with_label("5");
	gtk_table_attach_defaults (GTK_TABLE(table), button, 1, 2, 2, 3);
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
					   GTK_SIGNAL_FUNC(digit_button_clicked),
					   (gpointer)5);
	gtk_widget_show(button);
       
	button = gtk_button_new_with_label("6");
	gtk_table_attach_defaults (GTK_TABLE(table), button, 2, 3, 2, 3);
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
					   GTK_SIGNAL_FUNC(digit_button_clicked),
					   (gpointer)6);
	gtk_widget_show(button);
	button = gtk_button_new_with_label("CE");
	gtk_table_attach_defaults (GTK_TABLE(table), button, 3, 4, 4, 5);
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
					   GTK_SIGNAL_FUNC(operate_button_clicked),
					   (gpointer)CE);
	gtk_widget_show(button);
       
	button = gtk_button_new_with_label("1");
	gtk_table_attach_defaults (GTK_TABLE(table), button, 0, 1, 3, 4);
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
					   GTK_SIGNAL_FUNC(digit_button_clicked),
					   (gpointer)1);
	gtk_widget_show(button);
       
	button = gtk_button_new_with_label("2");
	gtk_table_attach_defaults (GTK_TABLE(table), button, 1, 2, 3, 4);
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
					   GTK_SIGNAL_FUNC(digit_button_clicked),
					   (gpointer)2);
	gtk_widget_show(button);
       
	button = gtk_button_new_with_label("3");
	gtk_table_attach_defaults (GTK_TABLE(table), button, 2, 3, 3, 4);
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
					   GTK_SIGNAL_FUNC(digit_button_clicked),
					   (gpointer)3);
	gtk_widget_show(button);
       
	button = gtk_button_new_with_label("+");
	gtk_table_attach_defaults (GTK_TABLE(table), button, 3, 4, 1, 2);
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
					   GTK_SIGNAL_FUNC(operate_button_clicked),
					   (gpointer)ADD);
	gtk_widget_show(button);
         
	button = gtk_button_new_with_label("-");
	gtk_table_attach_defaults (GTK_TABLE(table), button, 3, 4, 2, 3);
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
					   GTK_SIGNAL_FUNC(operate_button_clicked),
					   (gpointer)SUB);
	gtk_widget_show(button);
         
	button = gtk_button_new_with_label("=");
	gtk_table_attach_defaults (GTK_TABLE(table), button, 3, 4, 3, 4);
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
					   GTK_SIGNAL_FUNC(operate_button_clicked),
					   (gpointer)EQU);
	gtk_widget_show(button);
         
	button = gtk_button_new_with_label("0");
	gtk_table_attach_defaults (GTK_TABLE(table), button, 0, 1, 4, 5);
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
					   GTK_SIGNAL_FUNC(digit_button_clicked),
					   (gpointer)0);
	gtk_widget_show(button);

	button = gtk_button_new_with_label("RST");
	gtk_table_attach_defaults (GTK_TABLE(table), button, 0, 5, 5, 6);
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
					   GTK_SIGNAL_FUNC(rst_button_clicked),
					   (gpointer)NULL);
	gtk_widget_show(button);
       
	button = gtk_button_new_with_label("Q");
	gtk_table_attach_defaults (GTK_TABLE(table), button, 4, 5, 4, 5);
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
					   GTK_SIGNAL_FUNC(quit_button_clicked),
					   (gpointer)NULL);
	gtk_widget_show(button);
	gtk_widget_show(vbox);
	return;
}

void rst_button_clicked(GtkWidget *widget, gpointer data)
{
  rst.value.integer=1;
  gtk_main_quit();
	return;
}
void quit_button_clicked(GtkWidget *widget, gpointer data)
{
  gtk_main_quit();
#ifdef PLI
  tf_dofinish();
#else
  exit(0);
#endif
  return;
}

void digit_button_clicked(GtkWidget *widget, gpointer data)
{
  push.value.integer=1<<((int)data);
  gtk_main_quit();

	return;
}
         
void operate_button_clicked(GtkWidget *widget, gpointer data)
{
  switch((int)data){
    case    ADD: 
      plus.value.integer=1;
      break;
    case SUB:
      minus.value.integer=1;
      break;
    case EQU:
      equal.value.integer=1;
      break;
    case CE:
      ce.value.integer=1;
      break;
  default:
    printf("Error: %d\n",data);
  }
  gtk_main_quit();
  return;
}
       
int pli_calc_init(char *user_data)
{
	gtk_set_locale();
	gtk_init(0,NULL);
	/* initialize */
	calc_init();
	return(0);
}
#ifdef PLI       
int pli_calc_input(char *user_data)
{
  handle tfarg_push,tfarg_plus,tfarg_minus,tfarg_equal,tfarg_ce,tfarg_rst;
  tfarg_push = acc_handle_tfarg(1);
  tfarg_plus = acc_handle_tfarg(2);
  tfarg_minus = acc_handle_tfarg(3);
  tfarg_equal = acc_handle_tfarg(4);
  tfarg_ce = acc_handle_tfarg(5);
  tfarg_rst = acc_handle_tfarg(6);
  gtk_main();
  acc_set_value(tfarg_push,&push,&delay_none);
  acc_set_value(tfarg_plus,&plus,&delay_none);
  acc_set_value(tfarg_minus,&minus,&delay_none);
  acc_set_value(tfarg_equal,&equal,&delay_none);
  acc_set_value(tfarg_ce,&ce,&delay_none);
  acc_set_value(tfarg_rst,&rst,&delay_none);
  return(0);
}
int pli_calc_clear(char *user_data)
{
  handle tfarg_push,tfarg_plus,tfarg_minus,tfarg_equal,tfarg_ce,tfarg_rst;
  tfarg_push = acc_handle_tfarg(1);
  tfarg_plus = acc_handle_tfarg(2);
  tfarg_minus = acc_handle_tfarg(3);
  tfarg_equal = acc_handle_tfarg(4);
  tfarg_ce = acc_handle_tfarg(5);
  tfarg_rst = acc_handle_tfarg(6);
  push.value.integer=0;
  plus.value.integer=0;
  minus.value.integer=0;
  equal.value.integer=0;
  ce.value.integer=0;
  rst.value.integer=0;
  acc_set_value(tfarg_push,&push,&delay_none);
  acc_set_value(tfarg_plus,&plus,&delay_none);
  acc_set_value(tfarg_minus,&minus,&delay_none);
  acc_set_value(tfarg_equal,&equal,&delay_none);
  acc_set_value(tfarg_ce,&ce,&delay_none);
  acc_set_value(tfarg_rst,&rst,&delay_none);
  return(0);
}

int pli_display_led(char *user_data)
{
  handle tfarg_sign,tfarg_ledh,tfarg_ledl,tfarg_overflow;
  s_acc_value s_sign,s_ledh,s_ledl,s_overflow;
  s_sign.format=accIntVal;
  s_ledh.format=accIntVal;
  s_ledl.format=accIntVal;
  s_overflow.format=accIntVal;
  tfarg_sign=acc_handle_tfarg(1);
  tfarg_ledh=acc_handle_tfarg(2);
  tfarg_ledl=acc_handle_tfarg(3);
  tfarg_overflow=acc_handle_tfarg(4);
  acc_fetch_value(tfarg_sign,"%%",&s_sign);
  acc_fetch_value(tfarg_ledh,"%%",&s_ledh);
  acc_fetch_value(tfarg_ledl,"%%",&s_ledl);
  acc_fetch_value(tfarg_overflow,"%%",&s_overflow);
  sign=s_sign.value.integer;
  ledh=s_ledh.value.integer;
  ledl=s_ledl.value.integer;
  overflow=s_overflow.value.integer;
  expose_event(led_area,(GdkEventExpose *)NULL);
}

s_tfcell veriusertfs[] = {
 {usertask, 0, 0, 0, (int (*)()) pli_calc_init,  0, "$calc_init", 0 }, 
 {usertask, 0, 0, 0, (int (*)()) pli_calc_input,  0, "$calc_input", 0 }, 
 {usertask, 0, 0, 0, (int (*)()) pli_calc_clear,  0, "$calc_clear", 0 }, 
 {usertask, 0, 0, 0, (int (*)()) pli_display_led,  0, "$display_led", 0 }, 
 {0} /* this line must always be last */
};

s_tfcell *pli1_compat_bootstrap(void)
{
 return(veriusertfs);
}

#else

int main(int argc, char *argv[])
{
	int i;
	int port;
	char *hostname;
	gtk_set_locale();
	gtk_init(&argc, &argv);
	calc_init();
	while(1){
	  gtk_main();
	  printf("push=%x,plus=%x,minus=%x,equal=%x,ce=%x,rst=%x\n",
		 push.value.integer,plus.value.integer,minus.value.integer,
		 equal.value.integer,ce.value.integer,rst.value.integer);
	  calc_software();
	  expose_event(led_area,(GdkEventExpose *)NULL);
	}
}
#endif

